



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>调用系统api修改系统时间</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">调用系统api修改系统时间</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 16:01:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>一：截图</h4>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/612158/201406/011448440098502.png" /></p>
<h4>二：代码</h4>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.ComponentModel;<br />
using System.Data;<br />
using System.Drawing;<br />
using System.Text;<br />
using System.Windows.Forms;<br />
using System.Runtime.InteropServices;

namespace SetDate<br />
{<br />
    public partial class Frm_Main : Form<br />
    {<br />
        public Frm_Main()<br />
        {<br />
            InitializeComponent();<br />
        }

        public class SetSystemDateTime//自定义类SetSystemDateTime，用于设置系统日期,为了使用DllImportAttribute类（DllImportAttribute类是指可以将属性应用于方法，<br />
            //并由非托管动态链接库（DLL）作为静态入口点公开），<br />
            //需要引入命名空间：using System.Runtime.InteropServices;<br />
        {<br />
            [DllImportAttribute("Kernel32.dll")]//使用包含要导入的方法的 DLL 的名称初始化 DllImportAttribute 类的新实例。<br />
            public static extern void GetLocalTime(SystemTime st);//C#要设置系统时间必须要调用Win32的API，而其中相关的函数就是SetSystemTime(), GetSystemTimer(), SetLocalTime(), GetLocalTime(),<br />
            //这似乎是用VC写的函数，在VC++中是可以直接调用的。<br />
            //对于这两个函数，其输入参数必须是一个下面这样的结构体，其成员变量类型必须是ushort，成员变量不能改变顺序。<br />
            [DllImportAttribute("Kernel32.dll")]<br />
            public static extern void SetLocalTime(SystemTime st);<br />
        }

        [StructLayoutAttribute(LayoutKind.Sequential)]<br />
        public class SystemTime//自定义类SystemTime用于定义日期类<br />
        {<br />
            public ushort vYear;//年<br />
            public ushort vMonth;//月<br />
            public ushort vDayOfWeek;//星期<br />
            public ushort vDay;//日<br />
            public ushort vHour;//小时<br />
            public ushort vMinute;//分<br />
            public ushort vSecond;//秒<br />
        }

        private void button1_Click(object sender, EventArgs e)<br />
        {<br />
            this.textBox1.Text = DateTime.Now.ToString("F") +//得到系统时间<br />
                "  " + DateTime.Now.ToString("dddd");<br />
        }

        private void button2_Click(object sender, EventArgs e)<br />
        {<br />
            if (MessageBox.Show("您真的确定更改系统当前日期吗？",//设置系统当前日期时间<br />
                "信息提示", MessageBoxButtons.OK) == DialogResult.OK)<br />
            {<br />
                DateTime Year = this.dateTimePicker1.Value;//得到时间信息

                SystemTime MySystemTime = new SystemTime();//创建系统时间类的对象

                SetSystemDateTime.GetLocalTime(MySystemTime);//得到系统时间

                MySystemTime.vYear = (ushort)this.dateTimePicker1.Value.Year;//设置年<br />
                MySystemTime.vMonth = (ushort)this.dateTimePicker1.Value.Month;//设置月<br />
                MySystemTime.vDay = (ushort)this.dateTimePicker1.Value.Day;//设置日<br />
                MySystemTime.vHour = (ushort)this.dateTimePicker2.Value.Hour;//设置小时<br />
                MySystemTime.vMinute = (ushort)this.dateTimePicker2.Value.Minute;//设置分<br />
                MySystemTime.vSecond = (ushort)this.dateTimePicker2.Value.Second;//设置秒

                SetSystemDateTime.SetLocalTime(MySystemTime);//设置系统时间<br />
                button1_Click(null, null);//执行按钮点击事件<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv230x9.html">SQL Server 无法生成 FRunCM 线程。请查看 SQL Server 错误日志和 Windows 事件日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zy2e39.html">分析Mysql 5&period;6的Dockerfile</a>
		</li>
						<li><a href="https://www.batexi.com/a/39013vm8.html">MIPAV - Talairach ACPC transform</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql25ox8.html">【C语言入门教程】4&period;8 指针数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oen6x9.html">&lbrack;Java Web整合开发王者归来&amp;&num;183&semi;刘京华&rsqb; 2、 Java Web开发概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdep7zz9.html">用360安全浏览器控制网速，调试loading</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wke5lq.html">&period;NET开源工作流RoadFlow-系统布署及注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5vd1q.html">mui实现支付宝支付功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4jn2q.html">Yii2&period;0源码阅读-behavior的实现原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7xz69.html">实现iframe高度自适应</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p15p38.html">OperationCenter Docker容器启动脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7wyl8.html">php中数组直接用加号相加array&plus;array</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1n1e9.html">windows环境搭建nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdroeq.html">js中字符串转数组，数组转字符串及逆序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwvn79.html">poj-3928（树状数组）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gppwmz9.html">Maven最佳实践-distributionManagement</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjdjpo8.html">ASPX代码加固小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppk07k9.html">OpenGL入门程序三：点、线、面的绘制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppxl5y9.html">DHCP服务器备份、还原、迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kg0jwq.html">Codeforces 750 F：New Year and Finding Roots</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn1ek7x8.html">Maven Integration for Eclipse 正确地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m1vljq.html">关于黑名单IP的设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1z6469.html">重新看php数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m11rxq.html">Android开发手记&lpar;28&rpar; Handler和Looper</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0773gq.html">MVC中javascript直接调用Model</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v5gj48.html">&lbrack;转&rsqb;Delphi中ShellExecute的妙用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j073x0q.html">js正则验证方法大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x1mww9.html">python 数据结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zx1nz9.html">【BZOJ1036】【树链剖分】树的统计Count</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z17d6x9.html">linux之uniq</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
